﻿# fuelle-iterativ-HGT-tiefe-liste.py
# Programm zum Füllen eines Containers
# mit vollständigem Suchverfahren, bei dem
# alle Alternativen generiert werden und
# gleich getestet werden.
# Dies ist also "Hierarchical Generate and Test" HGT

# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]
def erzeuge_Container(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelle_ein(stueck, container):
    return [container[0], container[1]+[stueck]]

# Prädikat zum Testen, ob der Container voll ist.
def istVoll(container):
    return container[0]==sum(container[1])

def istZuVoll(container):
    return container[0]<sum(container[1])

def fuelle(stuecke, fassungsvermoegen):
    alternativen=[]
    # Alternativen sind: rein oder nicht rein
    for stueck in stuecke:
        ##print(alternativen,'\n')
        if alternativen==[]:
            alternativen=[[fassungsvermoegen,[stuecke[0]]],
                          [fassungsvermoegen,[]]]
        else:
            temp=[]
            for alt in alternativen:
                neu=fuelle_ein(stueck, alt)
                if istVoll(neu):
                    print('voll')
                    return neu
                if istZuVoll(neu):
                    temp+=[alt]
                else:
                    temp+=[neu,alt]
            alternativen=temp
    print('erfolglos')
    return []

### Tests
def ausgabe(stuecke, fassungsvermoegen):
    print('Stücke:', stuecke, fassungsvermoegen,
          'Ergebnis:\n', fuelle(stuecke, fassungsvermoegen), '\n')

ausgabe( [30,20], 50)
ausgabe( [80,90,30,20], 50)
ausgabe( stuecke, 80)
ausgabe( stuecke, 90)
ausgabe( stuecke, 170)
ausgabe( stuecke, 100)
ausgabe( stuecke*2, 200)
ausgabe( stuecke*3, 510)
ausgabe( stuecke*3, 1000)
